<?php
/*
Animation code by Marcello (http://www.cellosoft.com). Modified by RanmaGuy. Used with permission. This file is not to be used with any other script other than OekakiPoteto.

Wacintaki Poteto modifications Copyright 2004-2010 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.5.0 - Last modified 12/25/2009
*/


/*
NOTES:

Chibi Paint sends data as multipart encoded (yay!), so this code is quite different from the other oekaki applets.

Chibi Paint does not yet support animation data, but it is highly likely that the ".chi" layers file format will be used for animation in the future.  So, we'll save the file as an animation, anyway.  ;)
*/


// Error reporting
function print_ok() {
	global $dbconn;
	if (!empty ($dbconn)) {
		db_close();
	}

	header('Content-Type: text/plain');
	exit ("CHIBIOK\n");
}
function quiet_exit($exit_err) {
	global $dbconn;
	if (!empty ($dbconn)) {
		db_close();
	}

	header ('Content-Type: text/plain');
	exit ("CHIBIERROR {$exit_err}\n");
}


// Load bootstrap, quiet mode
// Get OekakiU any way we can!  boot.php will clean this.
$OekakiU    = '';
$OekakiPass = '';
if (isset ($_REQUEST['usr']) && isset ($_REQUEST['vcode'])) {
	// Preferred
	$OekakiU    = addslashes($_REQUEST['usr']);
	$OekakiPass = addslashes($_REQUEST['vcode']);
} elseif (isset ($_REQUEST['OekakiU']) && isset ($_REQUEST['OekakiPass'])) {
	// Backup
	$OekakiU    = $_REQUEST['OekakiU'];
	$OekakiPass = $_REQUEST['OekakiPass'];
}
if (empty ($OekakiU)) {
	// English only
	quiet_exit('Login could not be verified!  Take a screenshot of your picture.');
}
$quiet_mode  = TRUE;
$no_template = TRUE;
$no_online   = TRUE;
define ('BOOT', 1);
require ('boot.php');
require ('paintsave.php');


// Clean input
//$mode    = {boot.php};
$edittimes = w_gpc('edittimes', 'i');
$edit      = w_gpc('edit', 'i+');
$import    = w_gpc('import', 'i+');
$user_pass = w_gpc('pw'); // Encoded with make_edit_pass()



// ChibiPaint data
$buffer        = NULL;
$buffer_anim   = NULL;
$buffer_layers = NULL;
$got_chi_file  = FALSE;
{
	// Image
	if (!isset($_FILES['picture'])) {
		quiet_exit('No picture data was received. Try again.');
	}
	if ($_FILES['picture']['error'] > 0 || empty ($_FILES['picture']['tmp_name'])) {
		if ($_FILES['picture']['error'] == UPLOAD_ERR_NO_FILE) {
			quiet_exit('No picture data was received. Try again.');
		}
		quiet_exit('An error occured while uploading. Try again.');
	}
	if ($_FILES['picture']['size'] > $cfg['max_pic']) {
		quiet_exit('Picture too large!  Max size is '.$cfg['max_pic'].' bytes.');
	}
	$buffer = file_get_contents ($_FILES['picture']['tmp_name']);


	// Animation/layers
	// Uses move_uploaded_file() later in this script.
	if (isset ($_FILES['chibifile'])) {
		if ($_FILES['chibifile']['error'] == 0) {
			if ($_FILES['chibifile']['size'] <= $cfg['max_anim']) {
				$got_chi_file = TRUE;
			}
		}
	}
}


// Insert new slot into database
if ($mode == 'norm' || $mode == 'anim') {
	$resno = get_new_picnumber();
	if ($resno == 0) {
		w_log(WLOG_FAIL, 'chibipaintget: cannot allocate new PIC_ID');
		quiet_exit( t('err_picts'));
	}

	// Cleanup slots
	$result = clean_picture_slots();

	$thetime = time() - $edittimes;

	// Insert new slot
	$tries = 5;
	while ($tries > 0) {
		$sqlres = "INSERT INTO {$db_p}oekakidta SET usrname='$OekakiU', postdate=NOW(), hostname='$hostname', comment='', PIC_ID='$resno', IP='$address', datatype=4, edittime='$thetime', password=''";
		if ($mode == 'anim' || $got_chi_file) {
			$sqlres .= ', animation=1';
		} else {
			$sqlres .= ', animation=0';
		}
		$result = db_query ($sqlres);

		if ($result) {
			$tries = 0;
		} else {
			$tries--;
			sleep (1);
		}
	}
	if (!$result) {
		w_log_sql('chibipaintget: cannot save image '.$resno);
		quiet_exit( t('err_saveimg'));
	}
}


// Update edited slot to database
if ($mode == 'edit') {
	// Verify edit, otherwise invalidate it
	$resno = verify_edit($edit, $user_pass);

	$edittime2 = time() - $edittimes;
	$result2 = db_query ("UPDATE {$db_p}oekakidta SET edittime=(edittime + $edittime2) WHERE PIC_ID='$resno'");

	// Make sure animation file is updated/removed as neccesary
	// Chibi Paint is unique from the other applets in that animations (layers)
	//   can be invalidated by the applet, not just by the oekaki
	if ($got_chi_file) {
		// Add animation flag
		$result3 = db_query ("UPDATE {$db_p}oekakidta SET animation=1 WHERE PIC_ID='$resno'");
	} else {
		// Remove flag.  File deleted later
		$result3 = db_query ("UPDATE {$db_p}oekakidta SET animation=0 WHERE PIC_ID='$resno'");
	}

	// Check WIP status
	$result3 = db_query ("SELECT postlock FROM {$db_p}oekakidta WHERE PIC_ID='$resno'");
	if ($result3 && (db_result($result3, 0) != 1)) {
		$result3 = db_query ("UPDATE {$db_p}oekakidta SET postdate=NOW() WHERE PIC_ID='$resno'");
	}

}


// Write files
//
// Save image/anim data.  Filetype is automatic!
if (!save_image($buffer, $resno)) {
	w_log(WLOG_FAIL, 'chibipaintget: cannot save image '.$resno);
	quiet_exit( t('err_saveimg'));
}
if ($got_chi_file == TRUE) {
	move_uploaded_file ($_FILES['chibifile']['tmp_name'], $p_pic.$resno.'.chi');
} else {
	if (file_exists ($p_pic.$resno.'.chi')) {
		@unlink ($p_pic.$resno.'.chi');
	}
}


// Credit original artist, if required
if ($import) {
	$result = db_query ("SELECT usrname, origart FROM {$db_p}oekakidta WHERE PIC_ID='{$import}'");

	if ($result && db_num_rows ($result) > 0) {
		$import_check = db_fetch_array ($result);
		$import_check['usrname'] = addslashes ($import_check['usrname']);
		$import_check['origart'] = addslashes ($import_check['origart']);

		if ($import_check['usrname'] != $OekakiU) {
			// Not artist!  We'll need to update 'origart'.

			if ($import_check['origart'] != $OekakiU) {
				// Not original artist, either.  Update.
				$result2 = db_query ("UPDATE {$db_p}oekakidta SET origart='{$import_check['usrname']}' WHERE PIC_ID='{$resno}'");
			} else {
				// Retouched by original artist.  Clear 'origart' if set
				$result2 = db_query ("UPDATE {$db_p}oekakidta SET origart='' WHERE PIC_ID='{$resno}'");
			}
		}
	}
}


print_ok();

?>